'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.findJsdoc = findJsdoc;
exports.findOrCreateJsdoc = findOrCreateJsdoc;
exports.parseJsdoc = parseJsdoc;

var _doctrine = require('doctrine');

var _doctrine2 = _interopRequireDefault(_doctrine);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findJsdoc(node) {
    if (!node.leadingComments) {
        return undefined;
    }

    return node.leadingComments.find(function (comment) {
        return (/^\*(?:$|[^*])/.test(comment.value)
        );
    });
}

function findOrCreateJsdoc(path) {
    var jsdoc = findJsdoc(path.node);

    if (jsdoc) {
        return jsdoc;
    }

    path.addComment('leading', '*');
    return findJsdoc(path.node);
}

function parseJsdoc(comment) {
    if (!comment) {
        return null;
    }

    return _doctrine2.default.parse(comment || '', {
        unwrap: true,
        loose: true,
        sloppy: true
    });
}