'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (param, i, tags) {
    if (param.type === 'RestElement') {
        tags.push({
            title: 'param',
            name: param.argument.name,
            type: '...*'
        });
    } else if (param.type === 'AssignmentPattern') {
        var jsdocType = (0, _typeAnnotationToJsdocType2.default)(param.left.typeAnnotation && param.left.typeAnnotation.typeAnnotation);
        tags.push({
            title: 'param',
            name: param.left.name,
            default: param.right.value,
            type: jsdocType
        });
    } else {
        var _jsdocType = (0, _typeAnnotationToJsdocType2.default)(param.typeAnnotation && param.typeAnnotation.typeAnnotation);
        var optional = param.optional || param.typeAnnotation && param.typeAnnotation.typeAnnotation.type === 'NullableTypeAnnotation';

        recursiveTag(param.name || 'param' + (i + 1), tags, _jsdocType, optional);
    }
};

var _typeAnnotationToJsdocType = require('./typeAnnotationToJsdocType');

var _typeAnnotationToJsdocType2 = _interopRequireDefault(_typeAnnotationToJsdocType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function recursiveTag(paramName, tags, jsdocType, optional) {
    if (Array.isArray(jsdocType)) {
        tags.push({ title: 'param', name: paramName, optional: optional, type: 'Object' });
        jsdocType.forEach(function (objectTypeProperty) {
            return recursiveTag(paramName + '.' + objectTypeProperty.key.name, tags, (0, _typeAnnotationToJsdocType2.default)(objectTypeProperty.value), optional || objectTypeProperty.value.type === 'NullableTypeAnnotation');
        });
    } else {
        tags.push({ title: 'param', name: paramName, optional: optional, type: jsdocType });
    }
}